/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*; 
import javax.swing.*;

/**
 * classe de couplage du module aval d'absortion de CO2 dans du mthanol
 * 
 * @author Renaud GICQUEL
 */
public class MethanolAbsorOutlet extends ExtDivider 
{
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField epsi_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField colcCoolingLoad_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Compr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P;
    String linkProcess,outletFuelProcess,richMethanolProcess,richMethanolSubstanceName,outletFuelSubstanceName;
    String linkPoint,outletFuelPoint,richMethanolPoint;
    rg.corps.Corps richMethanolSubstance;
    rg.corps.Corps outletFuelSubstance;
    double flowAirPauvre,flowOutFuel;
    
    MethanolAbsorInlet inletMethanolAbsor;//module amont
    String inletMethanolAbsorName="";

    Vector fuelComp;
    Vector drySynGasComp;
    double epsi,tau;
    
    public MethanolAbsorOutlet (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,24,600,150);
		JLabel2.setText("conversion efficiency");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,0,164,20);
		JPanel1.add(epsi_value);
		epsi_value.setBounds(164,0,64,20);
		epsi_value.setText("0.95");
		JLabel1.setText("-33 C heat");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,24,164,20);
		JPanel1.add(colcCoolingLoad_value);
		colcCoolingLoad_value.setBounds(164,24,64,20);
		colcCoolingLoad_value.setText("0.5");
		JLabel3.setText("33 C heat");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(Q_value);
		Q_value.setBounds(164,48,64,20);
		Q_value.setText("0");
		JLabel4.setText("electric power consumed");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
		JPanel1.add(Compr_value);
		Compr_value.setBounds(164,72,64,20);
		Compr_value.setText("0");
		JLabel5.setText("outlet fuel temp. (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,164,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(164,96,64,20);
		Tout_value.setText("0");
		type=getType();
		thermoCouplerTypes=new String[2];
 		thermoCouplerTypes[0]="33C cooling";
		thermoCouplerTypes[1]="-33 C cooling";
   }
    public void init(){
	    getDividerStructure();
        checkConsistency();
		setupInletNode();
    }
    
    public String getType(){
        return "methanol absorber outlet";
    }
    
    private double getEpsilon(MethanolAbsorInlet inletMethanolAbsor){
        return Util.lit_d(epsi_value.getText());//lecture  l'cran de la valeur de espilon
    }
    
	public void calculateProcess(){
	
	    getDividerStructure();
        checkConsistency();
        if(inletMethanolAbsor==null)setupInletNode();
	    inletMethanolAbsor.calculateProcess();
	    
	    if((isBuilt)&&(inletMethanolAbsor.isBuilt)){//si les deux noeuds externes sont bien configurs
	        
	        fuelComp=inletMethanolAbsor.inputDrySynGasComp;
	        //les gaz amont et aval ont la mme composition
	        // la rserve prs qu'il n'y a plus de H2O
	        
            epsi=getEpsilon(inletMethanolAbsor);//mthode de calcul de epsilon
            tau=Util.lit_d(colcCoolingLoad_value.getText());

            //nombre de moles et dbit molaire de CO2 initial
            double xCO2=inletMethanolAbsor.fractCO2;
            double drySynGasMolFlow=inletMethanolAbsor.drySynGasFlow/inletMethanolAbsor.drySynGasM;
            
            double CO2MolFlow=drySynGasMolFlow*xCO2;
 
            //nombre de moles et dbit molaire de H2O initial
            double xH2O=inletMethanolAbsor.fractH2O;
            double H2OMolFlow=drySynGasMolFlow*xH2O;
                        
            //recalcul des fractions molaires pour tenir compte de l'extraction du CO2
	        for(int i=0;i<inletMethanolAbsor.inletDrySynGasFractmol.length;i++){//mise  jour des fractions molaire de sortie
	            double x_out=inletMethanolAbsor.inletDrySynGasFractmol[i]/(1-epsi*xCO2);
	            Util.updateMolarComp(fuelComp,inletMethanolAbsor.inletDrySynGasComp[i], x_out);
	        }
            double xCO2_out=(1-epsi)*xCO2/(1-epsi*xCO2);//fraction molaire de sortie en CO2
	        Util.updateMolarComp(fuelComp,"CO2", xCO2_out);
	        
            outletFuelSubstance.updateGasComposition(fuelComp);
            
            //recalcul des fractions molaires pour tenir compte de l'absorption de H2O
            
            //dtermination de la nouvelle fraction molaire de H2O avant extraction
            Integer ii=(Integer)fuelComp.elementAt(0);
	        int nComp=ii.intValue(); 
            Double[]fracMol= new Double[nComp];
            double[]fracmol= new double[nComp];
	        fracMol=(Double[])fuelComp.elementAt(2);
            for(int j=0;j<nComp;j++){
                fracmol[j]= fracMol[j].doubleValue();
            }   
            xH2O=Util.molarComp(fuelComp,"H2O");//fraction molaire de H2O
            
            //mise  jour des fractions molaires
	        for(int i=0;i<inletMethanolAbsor.inletDrySynGasFractmol.length;i++){
	            double x_out=fracmol[i]/(1-xH2O);
	            Util.updateMolarComp(fuelComp,inletMethanolAbsor.inletDrySynGasComp[i], x_out);
	        }
	        Util.updateMolarComp(fuelComp,"H2O", 0.);
            
            //mise  jour de la composition du combustible
            outletFuelSubstance.updateGasComposition(fuelComp);
            
            //calcul des dbits massiques en sortie
            
            double flowCO2Total=CO2MolFlow*44.0098;
            double flowCO2=flowCO2Total*epsi;
            double flowCombustible=inletMethanolAbsor.drySynGasFlow-flowCO2-H2OMolFlow*18.01528;
            double flowMethanol=flowCO2Total*5.76+flowCO2+H2OMolFlow*18.01528;
            
            double totalFlow=flowMethanol+flowCombustible;
            double Tmethanol=-12;

            double xMethanol=flowCO2/flowMethanol;//valeurs massiques
            System.out.println("x mthanol : "+xMethanol*44/18);
            
            //estimations par rgression
            double Tfuel=-79.4353224*epsi*epsi+	122.836604*epsi	-72.99350222;
            double wCompr=(515553.8648*epsi*epsi-686332.3952*epsi+1040734.905)/1000;
            double mediumCooling=-(7603999.601*epsi*epsi-13981544.78*epsi+6743213.887)/1000;//33 C = 306 K
            double coldCooling=-(-9713689.229*epsi*epsi+18154947.52*epsi-6997492.121)/1000;//-33 C = 240 K
            
            //mise  jour des thermocoupleurs, comme pinchFluid, DTmin=10
	        updateThermoCoupler("33C cooling", 306, 306, mediumCooling, flowMethanol,true,10);
	        updateThermoCoupler("-33 C cooling", 245, 235, coldCooling, flowMethanol,true,10);
	        
	        //affichage cran
            Q_value.setText(Util.aff_d(mediumCooling,2));
            Compr_value.setText(Util.aff_d(wCompr,2));
            colcCoolingLoad_value.setText(Util.aff_d(coldCooling,2));
            Tout_value.setText(Util.aff_d(Tfuel,2));
            
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(outletFuelProcess, outletFuelPoint, 0, flowCombustible, Tfuel+273.15, 23, 0);
	        //le dbit de mthanol est impos en sortie (il sera actualis en entre par le rgnrateur)
	        //le "titre en CO2" est impos en sortie (il faudrait ventuellement le propager)
	        setupVector(richMethanolProcess, richMethanolPoint, 1, flowMethanol, Tmethanol+273.15, 10, xMethanol);
	        setupVector(linkProcess, linkPoint, 2, totalFlow, Tfuel+273.15, 23, 0);
	        setupVector(linkProcess, linkPoint, 2, totalFlow, Tfuel+273.15, 23, 0);
            updateDivider(vTransfo,vPoints,Tfuel+273.15,inletMethanolAbsor.Htot);
            //le travail de compression est pris en compte comme nergie utile dans la transfo-point linkProcess
	        de.updateProcess(setEnergyTypes(linkProcess,wCompr,0,0));
        }
	}
    
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        outletFuelProcess="";
        richMethanolProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                if(typeSubst==4){//le corps d'entre est un gaz compos

                    //Check the substance at outlet
                    Vector vComp=lecorps.getGasComposition();
	                if(Util.contains(vComp,"H2")){
	                    outletFuelProcess=nomBranche[j];
	                    outletFuelPoint=amont;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=outletFuelProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        amont=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(amont);//direct parsing of point property vector
	                    outletFuelSubstance=lecorps;
	                    outletFuelSubstanceName=nomCorps;
	                }
	                else{
	                    outletFuelProcess=nomBranche[j];
	                    outletFuelPoint=amont;
	                }
	            }
                else if(typeSubst==5){//le corps d'entre est un corps externe
                    String nom=nomCorps;
	                if(nom.equals("methanol-CO2 mixture")){
	                    richMethanolProcess=nomBranche[j];
	                    richMethanolPoint=amont;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=richMethanolProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        amont=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(amont);//direct parsing of point property vector
	                    richMethanolSubstance=lecorps;
	                    richMethanolSubstanceName=nomCorps;
	                }
                }
	            else{//le corps de sortie n'est ni un gaz compos ni du methanol-CO2 mixture
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(de, msg);  
	            }
	        }
	        if((outletFuelProcess.equals(""))||(richMethanolProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        linkProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=linkProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
	    linkPoint=aval;
        String nom=nomCorps;
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "epsi_value");
        if(valeur!=null)epsi=Util.lit_d(valeur);
	    epsi_value.setText(Util.aff_d(epsi,3));
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "Q_value"));
	    Q_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Compr_value"));
	    Compr_value.setText(Util.aff_d(current,2));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"epsi_value="+epsi_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"Q_value="+Q_value.getText()+tab
	    +"Compr_value="+Compr_value.getText()+tab
	    ;
        return h;
    }
 
    void setupInletNode(){
        Vector vExt=proj.getExternalClassInstances();
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        String type=(String)obj[0];
	        if(type.equals("node")){
	            String main=(String)obj[4];
	            String nodeType=(String)obj[3];
	            if((main.equals(linkProcess))&&((nodeType.equals("methanol absorber inlet")))){
	                inletMethanolAbsor=(MethanolAbsorInlet)obj[1];
	                inletMethanolAbsorName=(String)obj[2];
	            }
	        }
        }
  }

}